//+------------------------------------------------------------------+
//|                                                 MyOrderClass.mq4 |
//|                        Copyright 2020, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2020, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "0.01"
#property strict

//--- User Inputs
	input int     order_deviation          = 2;       //order_deviation (int)
	input int     order_buffer             = 10;      //order_buffer (int)
	input int     order_max                = 8;       //order_max (int)
	input int     order_pending_expiry     = 12;      //order_pending_expiry (int)
	input double  order_profit_scale       = 1.0;     //order_profit_scale (double)

//--- Globals
    double    order_size_dbl_min,       // Actual Minimum Order Size in Pips
              order_size_dbl_max,       // Actual Maximum Order Size in Pips
              lot_display_small,        // Current Min Lot Size
              lot_display_large,        // Current Max Lot Size
              lot_max;                  // Max Lot Size for Pair

    int       magic_base,               // Final Magic Number
              total_orders_account,     // Total Open Orders
              real_order_cnt,           // Open Orders with correct Magic Number
              order_min_stoplevel,      // Stop Level for pair
              draw_line_length,         // Line size in Candles for Orders Drawings
              order_hold_cndl_cnt;      // Order Hold Candle Currentdown Value

    // double    old_order_array[10,10];   // OLD Order Array

    MyOrder   MyOrders[10];             // Order Pointer Array

int OnInit()
{
return(INIT_SUCCEEDED);
}

void OnDeinit(const int reason)
{
}

void OnTick()
{
	//--- My Signal finder here
	// Code for a signal being found here


	//--- Loop for empty slot and place order for found signal
	for (int i=0;i<10;i++)
	{
		//--- empty clot check
		if (MyOrders[i].ActiveOrder == NULL)
		{
			continue;
		} else {
			//--- populate Object with order data
			MyOrders[i].ActiveOrder = true;
		    MyOrders[i].SignalID    = 1;
		    MyOrders[i].OrderType   = OP_BUY;
		    MyOrders[i].OpenPrice   = 1.123;
		    MyOrders[i].StopLoss    = 1.023;
		    MyOrders[i].FirstTarget = 1.223;
		    MyOrders[i].TakeProfit  = 1.323;
		    MyOrders[i].MagicNumber = 123;
		    MyOrders[i].TicketID    = PlaceOrderFunc(MyOrders[i].OrderType,MyOrders[i].OpenPrice,MyOrders[i].StopLoss,MyOrders[i].TakeProfit,MyOrders[i].MagicNumber,order_deviation);
		    MyOrders[i].ParentID    = 0;
		}
	}
}

//+------------------------------------------------------------------+
//| Order Details Class                                              |
//+------------------------------------------------------------------+
	class MyOrder
	{
	  public:
	    bool ActiveOrder;
	    int SignalID;
	    int OrderType;
	    double OpenPrice;
	    double StopLoss;
	    double FirstTarget;
	    double TakeProfit;
	    int MagicNumber;
	    int TicketID;
	    int ParentID;

	  public:
	    MyOrder();
	    ~MyOrder();

	  public:
	    void ClearNow()
	    {
	      ActiveOrder  = NULL;
	      SignalID     = NULL;
	      OrderType    = NULL;
	      OpenPrice    = NULL;
	      StopLoss     = NULL;
	      FirstTarget  = NULL;
	      TakeProfit   = NULL;
	      MagicNumber  = NULL;
	      TicketID     = NULL;
	      ParentID     = NULL;
	    }

	};
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MyOrder::MyOrder()
  {
    ActiveOrder  = NULL;
    SignalID     = NULL;
    OrderType    = NULL;
    OpenPrice    = NULL;
    StopLoss     = NULL;
    FirstTarget  = NULL;
    TakeProfit   = NULL;
    MagicNumber  = NULL;
    TicketID     = NULL;
    ParentID     = NULL;
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MyOrder::~MyOrder()
  {
  }
//+------------------------------------------------------------------+
